#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/extensions/XTest.h>

int main (int argc, char *argv[]) {
 Display *dis;
 Window root;
 int screenNum;
 XEvent xev;
 Window curWin;
   
 dis = XOpenDisplay (NULL);
 screenNum = DefaultScreen (dis);
 root = RootWindow (dis, screenNum);
  
 if (GrabSuccess != (XGrabPointer (dis, 
  root, 1, 
  PointerMotionMask,
  GrabModeAsync, GrabModeAsync,
  None,
  None,
  CurrentTime
  ))) {
 
  fprintf (stderr, "unable to grab pointer");
  exit (1);
 }
  
 {
 int eventb;
 int errorb;
 int vmajor;
 int vminor;
  
 XTestQueryExtension (dis, &eventb, &errorb, &vmajor, &vminor);

 }
 XFlush (dis);
 
 XNextEvent (dis, &xev);
    
 while (1) {
  Window junk;
  Window child;
  int rx, ry;
  int x, y;
     
  XNextEvent (dis, &xev);
  
  switch (xev.type) {
   
   case MotionNotify:
    puts ("Motion");

    fprintf (stderr, "xev.xmotion.subwindow %ld\n", xev.xmotion.subwindow);
    
    /*XTestFakeMotionEvent (dis, screenNum, xev.xmotion.x_root, xev.xmotion.y_root, 0);*/
   break;
 
   case ButtonPress:
    puts ("ButtonPress");

    printf ("button %ld\n", xev.xbutton.button);
    /*XTestFakeButtonEvent(dis, xev.xbutton.button, 0, 0);*/
   break;
#ifdef BLAH
   case ButtonRelease:
    puts ("ButtonRelease");
    buttonsPressed = 0;
    XSendEvent (dis, child, 0, ButtonReleaseMask, &xev);
   break;
   
   case KeyPressMask:
    puts ("KeyPressMask");
    XSendEvent (dis, curWin, 0, KeyPressMask, &xev);
   
   case FocusIn:
   case FocusOut:
    puts ("Focus");
    XSendEvent (dis, curWin, 0, FocusChangeMask, &xev);
   break;
      
   case EnterNotify:
    /*
    XSendEvent (dis, xev.xcrossing.subwindow, 0, EnterWindowMask, &xev);
    XSetInputFocus (dis, child, RevertToParent, CurrentTime);
    */
    curWin = xev.xcrossing.subwindow;
   break;
    
   case LeaveNotify:
    puts ("Crossing");
    /*XSendEvent (dis, curWin, 0, LeaveWindowMask, &xev);
   */
#endif
   default:
   printf ("def\n");
  }

  XAllowEvents (dis, AsyncBoth, CurrentTime);
 } 

 return EXIT_SUCCESS;
}
