#include "TkXext.h"
#include "string.to.window.h"

int TkXext_MapWindow TCL_OBJ_CMD_ARGS {
 char *winStr;
 Tk_Window tkwin;
 Window w;
 Display *dis;

 if (2 != objc) {
  Tcl_WrongNumArgs (interp, 1, objv, "Window/XID");
  return TCL_ERROR;
 }
 
 tkwin = Tk_MainWindow (interp);
 Tk_MakeWindowExist (tkwin);
 dis = Tk_Display (tkwin);
 
 winStr = Tcl_GetString (objv[1]);
 
 if (TCL_OK != TkXext_StringToWindow (interp, winStr, &w)) {
  return TCL_ERROR;
 }
 
 XMapWindow (dis, w);
 XFlush (dis);

 return TCL_OK;
}

int TkXext_UnmapWindow TCL_OBJ_CMD_ARGS {
 char *winStr;
 Tk_Window tkwin;
 Window w;
 Display *dis;

 if (2 != objc) {
  Tcl_WrongNumArgs (interp, 1, objv, "Window/XID");
  return TCL_ERROR;
 }
 
 tkwin = Tk_MainWindow (interp);
 Tk_MakeWindowExist (tkwin);
 dis = Tk_Display (tkwin);
 
 winStr = Tcl_GetString (objv[1]);
 
 if (TCL_OK != TkXext_StringToWindow (interp, winStr, &w)) {
  return TCL_ERROR;
 }
 
 XUnmapWindow (dis, w);
 XFlush (dis);

 return TCL_OK;
}
